How to exit from shell script if above condition fails?


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting How to exit from shell script if above condition fails?
# 1  
Old 10-10-2013
Oracle How to exit from shell script if above condition fails?

HI

Code:
cd ${back_home}

if above back_home does not exist, then script shoul exit. Please let us know how to do that

Last edited by Scott; 10-10-2013 at 08:34 PM.. Reason: Added code tags
# 2  
Old 10-10-2013
Code:
[[ $? -eq 1 ]] && exit $?

Exits if previous command failed

Code:
[[ ! -d "/path/to/dir" ]] && exit 1

Exit if path doesnt exists

hth
# 3  
Old 10-10-2013
do i need to mention any if conditions?
# 4  
Old 10-10-2013
If $back_home is not defined then the command cd ${back_home} would evaluate to just cd (since "back_home" would evaluate to nothing). This would indeed take you "back home" (as in to your home directory - since cd with no arguments is equivalent to cd $HOME).

If you want to test if a variable is defined, you should use the test command!

Code:
test $back_home || exit

# 5  
Old 10-10-2013
we have $back_home variable is defined but problem is our code is like this

BACK_HOME is under NFS file system, today we have NFS file system was down
so script skips cd ${BACK_HOME} and deleted all jar files from root.

so i need to see if BACK_HOME not available then script should exit

below is the script

Code:
cd ${BACK_HOME}

# Remove old files here.
/usr/bin/find . -ctime +/-1 -name "*.jar" -print -exec /usr/bin/rm -rf {} \;


Last edited by Scott; 10-10-2013 at 08:54 PM.. Reason: Added code tags [10th time]
# 6  
Old 10-10-2013
This is a perfectly good example of how perfectly badly a question can be asked. Did you really think your problem was somehow related to that variable? Did you somehow magically expect us to work out it might have been an NFS problem?
# 7  
Old 10-10-2013
how to send email for below condition

[[ ! -d "/path/to/dir" ]] && exit 1
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

If condition fails for special charecter

I have a sample server name listed in variable as below: var="server-13" I need to check if the 7th character on $var is number 1 whichenv=`echo "$var"| head -c 7 | tail -c 1` if ]; then echo "9 found" else echo "9 Not Found" fi Output: This works... (3 Replies)
Discussion started by: mohtashims
3 Replies

2. UNIX for Beginners Questions & Answers

Linux shell | how to exit a script if any command fails.

Hi, i am new here let me say HI for all. now i have a question please: i am sending one command to my machine to create 3 names. if one of the names exists then the box return error message that already have the name but will continue to create the rests. How i can break the command and... (7 Replies)
Discussion started by: Amiri
7 Replies

3. Shell Programming and Scripting

Make expect exit the UNIX script in erreneous condition

Hi, I am writing a menu driven program using shell script. THe script will be collecting data by logging into the other servers and bringing back the data to home server to process it and accordingly issue commands. TO automate commands execution , I am using expect script. However I am not able... (5 Replies)
Discussion started by: ashima jain
5 Replies

4. Shell Programming and Scripting

If condition return 0 even when it fails to satisfy te condition

HI My doubt may be basic one but I need to get it clarified.. When i use "if" condition that checks for many AND, OR logical conditions like if ]; then return 0 fi Even the if condition fails it returns as zero.. Any clue.. But if i add else condition like if ]; ... (2 Replies)
Discussion started by: Priya Amaresh
2 Replies

5. UNIX for Dummies Questions & Answers

If condition fails, advise using wildcard

OS Environment: HP-UX B.11.31 U ia64 I am using the shell script code to connect to Oracle RAC database. Passing the parameter of cluster database name. typeset -l DB_ID=$1 + typeset -l DB_ID=sivDB #---- 3. SetDB validation ------------- if ; then print... (3 Replies)
Discussion started by: Siva SQL
3 Replies

6. Shell Programming and Scripting

Stop execution of script if some condition fails

After my if condtion give rusult true then script should stop execution. Please advice...Thnaks in advance (1 Reply)
Discussion started by: vivek1489
1 Replies

7. Shell Programming and Scripting

Exit for loop in a shell script if a condition is successfull

Hi All, I am stuch in a script where a for loop is running to execute some commands for some values. Now my problem is i have to have an if condition that if the first iteration is successful then it has to exit the for loop otherwise it has to continue normally. my code is this: for... (5 Replies)
Discussion started by: usha rao
5 Replies

8. Shell Programming and Scripting

How to print error and exit if command fails?

Guys any tips on printing a certain error message to stderr and exiting should a command fail within a ksh script? I'm trying to null some output files. Touch isn't suitable as i need to null them. print "" > file isn't suitable as i need to check elsehere for if they are 0bytes or not. ... (5 Replies)
Discussion started by: lavascript
5 Replies

9. Shell Programming and Scripting

why shell script fails?

hi , i m trying to run a shell script automatically , some time it works fine but some time it fails , what could be the problem . If anybody have an idea about this problem then reply . Thanks in advacne (4 Replies)
Discussion started by: tahir23
4 Replies

10. Shell Programming and Scripting

why shell script fails

hi .. I have automate some process on unix through sehll script . but i don't know there is some problem in scripts, some time shell script works and some time it fails. so my query is that "Why shell script fails some times?" thanks (4 Replies)
Discussion started by: tahir23
4 Replies
Login or Register to Ask a Question